package dev.shadowsoffire.apotheosis.ench.table;

package .tmp;

import dev.shadowsoffire.apotheosis.ench.table.EnchantingInfoScreen;
import net.minecraft.client.gui.components.AbstractSliderButton;
import net.minecraft.network.chat.Component;
import net.minecraft.util.Mth;

public class PowerSlider extends AbstractSliderButton {
  public PowerSlider(int x, int y, int width, int height) {
    super(x, y, width, height, (Component)Component.m_237119_(), 0.0D);
    if (EnchantingInfoScreen.this.selectedSlot != -1 && this.f_93577_ == 0.0D) {
      this.f_93577_ = normalizeValue((EnchantingInfoScreen.this.currentPower == 0) ? ((max() + min()) / 2) : EnchantingInfoScreen.this.currentPower);
      m_5697_();
    } 
    m_5695_();
  }
  
  protected void m_5695_() {
    m_93666_((Component)Component.m_237110_("info.apotheosis.slider_power", new Object[] { Integer.valueOf(this.this$0.currentPower) }));
  }
  
  protected void m_5697_() {
    EnchantingInfoScreen.this.currentPower = denormalizeValue(this.f_93577_);
    EnchantingInfoScreen.this.recomputeEnchantments();
  }
  
  public void setValue(int value) {
    if (!EnchantingInfoScreen.this.m_7282_()) {
      this.f_93577_ = normalizeValue(value);
      m_5697_();
      m_5695_();
    } 
  }
  
  public double normalizeValue(double value) {
    return Mth.m_14008_((snapToStepClamp(value) - min()) / (max() - min()), 0.0D, 1.0D);
  }
  
  public int denormalizeValue(double value) {
    return (int)snapToStepClamp(Mth.m_14139_(Mth.m_14008_(value, 0.0D, 1.0D), min(), max()));
  }
  
  private double snapToStepClamp(double valueIn) {
    if (step() > 0.0F)
      valueIn = (step() * (float)Math.round(valueIn / step())); 
    return Mth.m_14008_(valueIn, min(), max());
  }
  
  private int min() {
    return EnchantingInfoScreen.this.powers[EnchantingInfoScreen.this.selectedSlot][0];
  }
  
  private int max() {
    return EnchantingInfoScreen.this.powers[EnchantingInfoScreen.this.selectedSlot][1];
  }
  
  private float step() {
    return 1.0F / Math.max(max() - min(), 1);
  }
}
